require "thor"
require "minitest/naga"
require_relative "naga_api_client"

module Minitest
  module Naga
    class CLI < Thor
      desc "about", "A little information about minitest-naga."
      def about
        puts "minitest-naga is created by Wen Ting Wang as part of their final dissertation."
      end

      desc "wut", "wut"
      def wut
        puts "wut"*10
      end

      desc "hi", "hi"
      def hi
        puts "hi"*10
      end

      desc "rand", "Randomize me."
      def rand
        puts [
          "Batman is cool.",
          "When I finish cleaning whilst wearing rubber gloves, I use handwash to clean the gloves.",
          "I was listening to OneRepublic - Good Life, while writing this.",
          "Wobble wobble.",
          "Howdy!",
          "Why are you using this command? Shouldn't you be unit testing?",
          "'The night is darkest just before the dawn. I promise you, dawn is coming.'",
          "Sup?",
          "<ENTER SOMETHING RANDOM AND SILLY>",
          "Unagi!",
          "Salmon skin roll!",
          "I can count to 3. 1, 2, 3!",
          "Why Naga you ask? Well, this creator here watched a TV show called the Legend of Korra. Korra, the main character, has a polar-bear-dog called Naga and well basically I want one. So the system is codenamed Naga. I say codenamed because I'm pretty much waiting for someone to tell me off and say 'Hey missy, you ain't allowed to use the name Naga! I own it!'. So until that day comes, Naga it is.",
          "Everything will be okay."
        ].sample
      end

      desc "ty", "Thank you."
      def ty
        puts "Thank you so much for using Naga! If it has been even the tiniest bit fun for you, then that makes me really happy. If you actually liked it even a little bit, then that makes me even happier. K, bye. *creator flies away*"
        puts "- Ting"
      end

      desc "signout", "Sign out of Naga."
      def signout
        if File.file?(NagaApiClient.FILE_PATH)
          File.delete(NagaApiClient.FILE_PATH)
          puts "Signed out."
        end
      end
    end
  end
end
