class NagaApiClient
  # @@BASE_URL = "http://localhost:3000/api/v1/"
  @@BASE_URL = "https://naga-unit-testing.herokuapp.com/api/v1/"
  @@FILE_PATH = File.join(Dir.home, ".minitest_naga")

  attr_reader :credentials
  attr_reader :email
  attr_reader :authentication_token

  def initialize
    @options = { headers: { "Content-Type" => "application/x-www-form-urlencoded" } }
    @authenticated = false
    if File.file?(@@FILE_PATH)
      @credentials = eval(File.read(@@FILE_PATH))
      validate(@credentials)
    else
      authenticate
    end
  end

  def self.BASE_URL
    @@BASE_URL
  end

  def self.FILE_PATH
    @@FILE_PATH
  end

  def credentials
    @credentials = { email: @email, authentication_token: @authentication_token }
  end

  def authenticated?
    @authenticated
  end

  private

  def authenticate
    cli = HighLine.new
    email = cli.ask "Enter your email: "
    password = cli.ask("Enter your password: ") { |q| q.echo = false }
    url = @@BASE_URL + "sessions"
    options = @options
    options[:body] = "email=" + email + "&password=" + password
    response = HTTParty.post(url, options)
    parsed_response = response.parsed_response
    if parsed_response["error"]
      STDERR.puts(("Error: " + parsed_response["error"]).colorize(:red))
      @authenticated = false
      authenticate
    else
      puts "Authentication successful".colorize(:green)
      f = File.open(@@FILE_PATH, "w")
      f.write(parsed_response)
      f.close
      @email = parsed_response["email"]
      @authentication_token = parsed_response["authentication_token"]
      @authenticated = true
    end
  end

  def validate(credentials)
    url = @@BASE_URL + "sessions/validate"
    options = @options
    options[:body] = "email=" + credentials["email"] + "&authentication_token=" + credentials["authentication_token"]
    response = HTTParty.post(url, options)
    parsed_response = response.parsed_response
    if parsed_response["error"]
      STDERR.puts(("Error: " + parsed_response["error"]).colorize(:red))
      @authenticated = false
      authenticate
    else
      @authenticated = true
      @email = parsed_response["email"]
      @authentication_token = parsed_response["authentication_token"]
      puts "Signed in as " + @email
    end
  end
end
