require "highline/import"
require "httparty"
require "colorize"
require "colorized_string"
require "uri"
require_relative "naga/achievement"
require_relative "naga/cli"
require_relative "naga/detector"
require_relative "naga/naga_api_client"
require_relative "naga/naga_reporter"
require_relative "game/game"
require_relative "game/inventory"
require_relative "game/item"
require_relative "game/location"
require_relative "game/place"

module Minitest
  def self.plugin_naga_options(opts, options)
    opts.on "--naga", "Run tests with Naga." do
      options[:naga] = true
    end
  end

  def self.plugin_naga_init(options)
    Minitest.reporter << NagaReporter.new(options[:io], options)
  end
end
